/*============================================================================
 *
 * ZZplayer : MPEG-I video player
 * Copyright (C) 1999 Nicolas Vignal <nicolas.vignal@fnac.net
 * Home    : http://www.chez.com/tsc/zzplayer/zzplayer.html
 *
 *
 * $Id: callbacks.c,v 1.1 2001/05/13 11:04:51 jay Exp $
 *
 * File    : interface.c
 * Author  : Jayan S Rangan
 * E-Mail  : jayansr@users.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

============================================================================*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <string.h>

#include "callbacks.h"
#include "interface.h"
#include "fmpeg.h"

gint app_quit_callback( GtkWidget *w, gpointer file_name )
{
  //so we are going to quit the application				
  gtk_main_quit();	
	return FALSE;
}

void about_callback ( GtkWidget *w, gpointer p )
{
  GtkWidget *aboutBox;
	aboutBox = create_about();
	gtk_widget_show( aboutBox );
}

void pause_callback( GtkWidget *w, gpointer file_name )
{
  if( GTK_TOGGLE_BUTTON(w)->active ) {				
    pause_mpeg();
  } else {
    pause_mpeg();
  }		
}

void stop_callback( GtkWidget *w, gpointer p )
{	
	gtk_toggle_button_set_active( (GtkToggleButton *)p, FALSE );
  stop_mpeg();
}

void loop_callback( GtkWidget *w, gpointer p )
{
  ( GTK_TOGGLE_BUTTON(w)->active )? unloop_mpeg( ): loop_mpeg( );
}	

void zoom_callback( GtkWidget *w, gpointer p )
{
 ( GTK_TOGGLE_BUTTON(w)->active )? zoom_mpeg( 1 ): zoom_mpeg( 0 );				
}

void slider_moved_callback( GtkAdjustment *a )
{
	seek_mpeg( (int)a->value );
	//printf("--\n");
}

void volume_changed_callback( GtkAdjustment *a )
{
  set_volume_mpeg((int)a->value);
}
