/*============================================================================
 *
 * ZZplayer : MPEG-I video player
 * Copyright (C) 1999 Nicolas Vignal <nicolas.vignal@fnac.net
 * Home    : http://www.chez.com/tsc/zzplayer/zzplayer.html
 *
 *
 * $Id: fmpeg.h,v 1.1 2001/05/13 11:04:24 jay Exp $
 *
 * File    : interface.c
 * Author  : Jayan S Rangan
 * E-Mail  : jayansr@users.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

============================================================================*/


#include <SDL/SDL.h>
#include <smpeg/smpeg.h>

#include <stdlib.h>
#include <string.h>


#define MPEG_SUCCESS     0
#define VIDEO_ERROR	     1
#define AUDIO_ERROR      2
#define SMPEG_OPEN_ERROR 3
#define SMPEG_INIT_ERROR 4
#define FILE_NULL        5
#define NO_MPEG          6
#define LOOP_MPEG        1
#define LOOP_MPEG_NO     0

struct t_fvideo {

	SMPEG *mpeg;
	SMPEG_Info info;
	SDL_Surface *sdl_screen;
	SDL_Event event;
	int enable_audio;
};	
typedef struct t_fvideo fvideo;

void init_mpeg(void);
int sdl_initialize( );
int play_mpeg(char *);
int pause_mpeg( );
int loop_mpeg( );
int unloop_mpeg( );
int stop_mpeg( );
int zoom_mpeg( int );
int get_mpeg_info(int *, double*, int* );
uint get_mpeg_offset();
void set_volume_mpeg( int );
