/*============================================================================
 *
 * ZZplayer : MPEG-I video player
 * Copyright (C) 1999 Nicolas Vignal <nicolas.vignal@fnac.net
 * Home    : http://www.chez.com/tsc/zzplayer/zzplayer.html
 *
 *
 * $Id: interface.c,v 1.1 2001/05/13 11:05:06 jay Exp $
 *
 * File    : interface.c
 * Author  : Jayan S Rangan
 * E-Mail  : jayansr@users.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

============================================================================*/


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "fmpeg.h"

#include "../pixmaps/prevtrack.xpm"
#include "../pixmaps/nexttrack.xpm"
#include "../pixmaps/loop.xpm"
#include "../pixmaps/fullscreen.xpm"
#include "../pixmaps/help.xpm"
#include "../pixmaps/pause1.xpm"
#include "../pixmaps/stop.xpm"
#include "../pixmaps/open.xpm"

gchar file_name[256];
GtkWidget *file_sel;
int loop=LOOP_MPEG_NO;
void timer_callback(  gpointer P );
GtkWidget *label1;
GtkObject *adj_seek, *adj_vol;

GtkWidget*
create_window1 (void)
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *hbox3;
  GtkWidget *previous_button;
  GtkWidget *pause_button;
  GtkWidget *next_button;
  GtkWidget *stop_button;
  GtkWidget *open_button;
  GtkWidget *loop_button;
  GtkWidget *about_button;
  GtkWidget *fullscreen_button;
  GtkWidget *hbox1;
  GtkWidget *pixmap2;
  GtkWidget *hscale2;
  GtkWidget *hbox2;
  GtkWidget *pixmap1;
  GtkWidget *hscale1;
  GtkWidget *frame1;
  GtkWidget *prev_box, *pause_box, *next_box, *stop_box, *open_box, *loop_box, *fullscreen_box, *about_box;
  GtkWidget *prev_win, *pause_win, *next_win, *stop_win, *open_win, *loop_win, *fullscreen_win, *about_win;



  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), _("Gmpeg"));

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 3);

	gtk_signal_connect( GTK_OBJECT(window1), "delete_event",
									    GTK_SIGNAL_FUNC( app_quit_callback ), NULL );


  /* previous button*/
  previous_button = gtk_button_new ( );
  gtk_widget_set_usize( previous_button, 30, 20 );
  prev_box = gtk_vbox_new( FALSE, 0 );
  gtk_container_add(GTK_CONTAINER(previous_button), prev_box);
  prev_win = gnome_pixmap_new_from_xpm_d (prevtrack_xpm);
  gtk_box_pack_start(GTK_BOX(prev_box), prev_win, FALSE, FALSE, 0);
  gtk_widget_show( previous_button);
  gtk_widget_show( prev_box );
  gtk_widget_show( prev_win );
  gtk_box_pack_start (GTK_BOX (hbox3), previous_button, TRUE, FALSE, 1);
	gtk_tooltips_set_tip( gtk_tooltips_new(), previous_button, "Previous frame",
									NULL );

  /* pause button */
  pause_button = gtk_toggle_button_new ( );
  gtk_widget_set_usize( pause_button, 30, 20 );
  pause_box = gtk_vbox_new( FALSE, 0 );
  gtk_container_add(GTK_CONTAINER(pause_button), pause_box);
  pause_win = gnome_pixmap_new_from_xpm_d (pause1_xpm);
  gtk_box_pack_start(GTK_BOX(pause_box), pause_win, FALSE, FALSE, 0);
  gtk_widget_show( pause_button);
  gtk_widget_show( pause_box );
  gtk_widget_show( pause_win );
  gtk_box_pack_start (GTK_BOX (hbox3), pause_button, TRUE, FALSE, 1);
  gtk_signal_connect(GTK_OBJECT(pause_button), "clicked",
                     GTK_SIGNAL_FUNC(pause_callback), file_name );
	gtk_tooltips_set_tip( gtk_tooltips_new(), pause_button, "Pause/Play",
									NULL );

  /*next button*/
  next_button = gtk_button_new( );
  gtk_widget_set_usize( next_button, 30, 20 );
  next_box = gtk_vbox_new( FALSE, 0 );
  gtk_container_add(GTK_CONTAINER(next_button), next_box);
  next_win = gnome_pixmap_new_from_xpm_d (nexttrack_xpm);
  gtk_box_pack_start(GTK_BOX(next_box), next_win, FALSE, FALSE, 0);
  gtk_widget_show( next_box );
  gtk_widget_show( next_win );
  gtk_widget_show (next_button);
  gtk_box_pack_start (GTK_BOX (hbox3), next_button, TRUE, FALSE, 1);
	gtk_tooltips_set_tip( gtk_tooltips_new(), next_button, "Next frame",
									NULL );

  /* stop button */
  stop_button = gtk_button_new();
  gtk_widget_set_usize( stop_button, 30, 20 );
  stop_box = gtk_vbox_new( FALSE, 0 );
  gtk_container_add(GTK_CONTAINER(stop_button), stop_box);
  stop_win = gnome_pixmap_new_from_xpm_d (stop_xpm);
  gtk_box_pack_start(GTK_BOX(stop_box), stop_win, FALSE, FALSE, 0);
  gtk_widget_show( stop_box );
  gtk_widget_show( stop_win );
  gtk_widget_show (stop_button);
  gtk_box_pack_start (GTK_BOX (hbox3), stop_button, TRUE, FALSE, 1);
  gtk_signal_connect(GTK_OBJECT(stop_button), "clicked",
                     GTK_SIGNAL_FUNC(stop_callback), pause_button );
	gtk_tooltips_set_tip( gtk_tooltips_new(), stop_button, "Stop",
									NULL );

  /*open button */
  open_button = gtk_button_new();
  gtk_widget_set_usize( open_button, 30, 20 );
  open_box = gtk_vbox_new( FALSE, 0 );
  gtk_container_add(GTK_CONTAINER(open_button), open_box);
  open_win = gnome_pixmap_new_from_xpm_d (open_xpm);
  gtk_box_pack_start(GTK_BOX(open_box), open_win, FALSE, FALSE, 0);
  gtk_widget_show( open_box );
  gtk_widget_show( open_win );
  gtk_widget_show (open_button);
  gtk_box_pack_start (GTK_BOX (hbox3), open_button, TRUE, FALSE, 1);
  gtk_signal_connect(GTK_OBJECT(open_button), "clicked",
                     GTK_SIGNAL_FUNC(open_callback), file_sel);
	gtk_tooltips_set_tip( gtk_tooltips_new(), open_button, "Open and Play",
									NULL );

  /*loop button */
  loop_button = gtk_toggle_button_new();
  gtk_widget_set_usize( loop_button, 30, 20 );
  loop_box = gtk_vbox_new( FALSE, 0 );
  gtk_container_add(GTK_CONTAINER(loop_button), loop_box);
  loop_win = gnome_pixmap_new_from_xpm_d (loop_xpm);
  gtk_box_pack_start(GTK_BOX(loop_box), loop_win, FALSE, FALSE, 0);
  gtk_widget_show( loop_box );
  gtk_widget_show( loop_win );
  gtk_widget_show (loop_button);
  gtk_box_pack_start (GTK_BOX (hbox3), loop_button, TRUE, FALSE, 1);
  gtk_signal_connect(GTK_OBJECT(loop_button), "clicked",
                     GTK_SIGNAL_FUNC(loop_callback), &loop );
	gtk_tooltips_set_tip( gtk_tooltips_new(), loop_button, "Endless play",
									NULL );

  /*full_screen button */
  fullscreen_button = gtk_toggle_button_new();
  gtk_widget_set_usize( fullscreen_button, 30, 20 );
  fullscreen_box = gtk_vbox_new( FALSE, 0 );
  gtk_container_add(GTK_CONTAINER(fullscreen_button), fullscreen_box);
  fullscreen_win = gnome_pixmap_new_from_xpm_d (fullscreen_xpm);
  gtk_box_pack_start(GTK_BOX(fullscreen_box), fullscreen_win, FALSE, FALSE, 0);
  gtk_widget_show( fullscreen_box );
  gtk_widget_show( fullscreen_win );
  gtk_widget_show (fullscreen_button);
  gtk_box_pack_start (GTK_BOX (hbox3), fullscreen_button, TRUE, FALSE, 0);
	gtk_signal_connect( GTK_OBJECT(fullscreen_button), "clicked",
									    GTK_SIGNAL_FUNC( zoom_callback ), NULL );
	gtk_tooltips_set_tip( gtk_tooltips_new(), fullscreen_button, "Zoom ",
									NULL );

	/*about button */
  about_button = gtk_button_new();
  gtk_widget_set_usize( about_button, 30, 20 );
  about_box = gtk_vbox_new( FALSE, 0 );
  gtk_container_add(GTK_CONTAINER(about_button), about_box);
  about_win = gnome_pixmap_new_from_xpm_d (help1);
  gtk_box_pack_start(GTK_BOX(about_box), about_win, FALSE, FALSE, 0);
  gtk_widget_show( about_box );
  gtk_widget_show( about_win );
  gtk_widget_show (about_button);
  gtk_box_pack_start (GTK_BOX (hbox3), about_button, FALSE, TRUE, 10 );
  gtk_signal_connect(GTK_OBJECT(about_button), "clicked",
                     GTK_SIGNAL_FUNC(about_callback), about_button );
	gtk_tooltips_set_tip( gtk_tooltips_new(), about_button, "Help/About ",
									NULL );


  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  pixmap2 = create_pixmap (window1, "../pixmaps/video.xpm", FALSE);
  gtk_widget_ref (pixmap2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "pixmap2", pixmap2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap2);
  gtk_box_pack_start (GTK_BOX (hbox1), pixmap2, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (pixmap2), 0.5, 0.82);

	adj_seek = gtk_adjustment_new( 0, 0, 100, 1, 10, 0);
  hscale2 = gtk_hscale_new (GTK_ADJUSTMENT (adj_seek ));
  gtk_widget_ref (hscale2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hscale2", hscale2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hscale2);
	gtk_signal_connect( GTK_OBJECT( adj_seek ), "changed",
									GTK_SIGNAL_FUNC( slider_moved_callback ), NULL );
	
  gtk_box_pack_start (GTK_BOX (hbox1), hscale2, TRUE, TRUE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  pixmap1 = create_pixmap (window1, "../pixmaps/sound.xpm", FALSE);
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox2), pixmap1, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (pixmap1), 0.5, 0.86);

	adj_vol = gtk_adjustment_new (0, 0, 100, 1, 10, 0);
  hscale1 = gtk_hscale_new (GTK_ADJUSTMENT (adj_vol));
  gtk_widget_ref (hscale1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hscale1", hscale1,
                            (GtkDestroyNotify) gtk_widget_unref);
	gtk_adjustment_set_value( GTK_ADJUSTMENT(adj_vol), 50 );
  gtk_widget_show (hscale1);
	gtk_signal_connect( GTK_OBJECT(adj_vol), "value_changed", 
									GTK_SIGNAL_FUNC(volume_changed_callback), NULL );
  gtk_box_pack_start (GTK_BOX (hbox2), hscale1, TRUE, TRUE, 0);
//
//

  frame1 = gtk_frame_new (NULL);
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (hbox2), frame1, TRUE, TRUE, 4);
	//gtk_container_set_border_width ( (GTK_CONTAINER(frame1), 2 ));

  label1 = gtk_label_new (" ");
	gtk_label_set_text(GTK_LABEL(label1), (char*)"Fps: \nFrame:"); 
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_container_add (GTK_CONTAINER (frame1), label1);
	gtk_misc_set_alignment (GTK_MISC (label1), 0.04, 0.51);
	gtk_label_set_justify( GTK_LABEL(label1), GTK_JUSTIFY_LEFT );

  return window1;
}


//callbacks
void open_callback ( GtkWidget *w,   GtkWidget *file_sel )
{

  file_sel = gtk_file_selection_new ( "Open" );
  

  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
                                            (file_sel)->cancel_button),
             "clicked", (GtkSignalFunc) gtk_widget_destroy,
             GTK_OBJECT (file_sel));

  gtk_signal_connect ( GTK_OBJECT (GTK_FILE_SELECTION
                                     (file_sel)->ok_button),
              "clicked", (GtkSignalFunc) file_ok_clicked_callback, file_sel );

  gtk_widget_show ( file_sel );
}

void file_ok_clicked_callback ( GtkWidget *w, GtkFileSelection *fs )
{
  char *file = gtk_file_selection_get_filename ( GTK_FILE_SELECTION (fs));
  memcpy ( file_name, file, strlen(file) );
  g_print ( "file selected : %s\n", file_name );
  gtk_widget_destroy( GTK_WIDGET (fs) );
	gtk_timeout_add( 1000, timer_callback, NULL );
  play_mpeg( (char*)file_name );
}

void timer_callback( gpointer p )
{
  char label_text[50];
	int seek;
	double fps;
	int frame;

  get_mpeg_info( &seek, &fps, &frame  );
//	fprintf ( stderr, "%d %d %d\n", fps, frame,
//									seek );
	sprintf(label_text, "Fps: %.2f\nFrame: %5i", fps, frame );
	gtk_label_set_text( (GtkLabel*)label1, label_text );
	gtk_adjustment_set_value( GTK_ADJUSTMENT( adj_seek), seek );
}



GtkWidget*
create_about (void)
{
  const gchar *authors[] = {
				    "Jayan. S. R  <jayansr@users.sourceforge.net>",
				    NULL
  };
  GtkWidget *about1;

  about1 = gnome_about_new ("Gmpeg", "0.9.1",
                  _("(C) 2000-2001 Jayan. S. R"),
                  authors,
                  _("Gmpeg an MPEG-1 player\nWeb: <gmpeg.sourceforge.net>"),
                  "zzplayer/gmpeglogo.bmp");
  gtk_object_set_data (GTK_OBJECT (about1), "about1", about1);
  gtk_window_set_modal (GTK_WINDOW (about1), TRUE);

  return about1;
}

